   ' Melodieklingel   -   Guido Scheidat
   ' Nachbau der Melodieklingel aus FA 4/86 mit modernen Bauteilen
   ' bernahme aller Melodien aus der "Funkamateur"

   ' ATmega8
   ' intern 8 MHz
   ' Pin 6 (PD2 / INT0) - Klingeltaster gegen Masse
   ' Pin 15 (PB3 / OC1A) - Ausgang zum Lautsprecher

   ' Umgeschrieben fr ATiny2313 -  Jochen Blke
   ' erweitert um 10 Weihnachtslieder (Originale Funkamateur)
   ' intern 8 MHz
   ' Pin 6 (PD2 / INT0) - Klingeltaster gegen Masse
   ' Pin 15 (PB3 / OC1A) - Ausgang zum Lautsprecher
   ' Pin 8 (PD4 )     - Schalter fr Weihnachtslieder gegen Masse
   ' Powersave-Modus eingefhrt um auch Batteriebetrieb zu ermglichen



    $regfile = "ATtiny2313.dat"
    $crystal = 8000000


   Dim Viertel As Byte
   Dim I As Byte
   Dim Lang As Byte
   Dim Aktton As Byte
   Dim Liedcount As Integer
   Dim Enderr As Bit
   Dim Lied As Word
   Dim Merker As Bit
   Dim Tonan As Bit

   Const Speed = 4                                          'darf nicht 0 sein
   Merker = 1                                               'die normalen Lieder werden gespielt
   Tonan = 0
   Liedcount = 0
   Lang = 1
   Enderr = 0
   Viertel = 1
   Set Portd.2                                              'Pull-up ein
   Set Portd.4                                              'Pull-up ein
   Config Portd.4 = Input
   Config Portb.3 = Input                                   'SOUNDOFF
   Config Int0 = Low Level


'*** Timer 1 einstellen
   'Vorteiler auf 1
   Set Tccr1b.cs10
   Reset Tccr1b.cs11
   Reset Tccr1b.cs12

   'Toggle OC1A on Compare Match
   Reset Tccr1a.com1a1
   Set Tccr1a.com1a0

   'Waveform Generation Mode --> Mode 4; CTC
   'WGM13 = 0
   'WGM12 = 1
   'WGM11 = 0
   'WGM10 = 0
   Reset Tccr1b.wgm13
   Set Tccr1b.wgm12
   Reset Tccr1a.wgm10
   Reset Tccr1a.wgm11

'*** Timer 0 einstellen
   Config Timer0 = Timer , Prescale = 1024                  'Konfiguriere Timer0
   On Timer0 Isr_timer0                                     'verzweige bei Timer0-berlauf zu ISR_Timer0
   Timer0 = 256 - 243                                       'Timer0 Zeit fr 1/8 Note / 4
   Enable Timer0                                            'schalte den Timer0 ein

'*** externen Interrupt 0 einstellen
   Config Int0 = Low Level                                  'configuriere Int0 Auf Low Level
   On Int0 Isr_int0                                         'springe zu ISR_Int0
   Enable Int0                                              'einschalten von Interrupt Int0

'*** Behandlung von Interrupts
   Enable Interrupts                                        'Einschalten der Interrupts


'*** Hauptprogramm
   Do
    '....Hauptprogramm     --  es gibt ein Hauptprogramm, das nur wartet
    '                          bis alle Interrupts abgearbeitet sind, um sich dann
    '                          wieder schlafen zu legen !

    Warte:
    If Tonan = 1 Then
         Goto Warte
    End If
    Power Powerdown

    Waitms 10                                               'Sicherheitshalber warten wir 10ms bevor die
                                                             'Schleife erneut begonnen wird

    Loop
   End



'*** Interrupt-Routine fr Timer 0
   Isr_timer0:                                              'ISR von Timer0
      Tonan = 1                                             'Ton wird ausgegeben, Powersave gestoppt
      Viertel = Viertel - 1
      If Viertel = 0 Then
         Viertel = Speed
         Lang = Lang - 1
         If Lang = 0 Then
            If Enderr = 1 Then
               'Timer / Counter0 Overflow Interrupt Disable
               Disable Timer0                               'schalte den Timer0 aus
               Config Portb.3 = Input                       'SOUNDOFF
               Enable Int0                                  'es kann geschlafen werden
               Tonan = 0                                    'INT0 erlauben
            Else
               If Merker = 1 Then
                           Aktton = Lookup(liedcount , Lied)
                  Else
                           Aktton = Lookup(liedcount , Weihnachten)       'bei Merker=0 also PD4=0
               End If

               If Aktton.7 = 1 Then Enderr = 1              'Liedende gefunden
               Lang = Aktton                                'Tonlnge ermitteln
               Shift Lang , Right , 4                       'Division durch 16
               Lang = Lang And &H07
               Lang = Lang + 1
               Aktton = Aktton And &H0F
               If Aktton = 0 Then
                  Config Portb.3 = Input                    'SOUNDOFF
               Else
                  Aktton = Aktton - 1
                  Reset Tccr1b.cs10                         'CTC aus
                  Shift Aktton , Left , 1                   'Multiplikation mit 2
                  Ocr1ah = Lookup(aktton , Tone)            'Tonhhe
                  Aktton = Aktton + 1
                  Ocr1al = Lookup(aktton , Tone)            'Tonhhe
                  Tcnt1l = 0                                'Zhler soll bei 0 beginnen
                  Tcnt1h = 0
                  Set Tccr1b.cs10                           'CTC ein
                  Config Portb.3 = Output                   'SOUNDON
               End If
               Liedcount = Liedcount + 1                    'nchste Note
               'Aktton = Lookup(liedcount , Lied)
               If Merker = 1 Then
                           Aktton = Lookup(liedcount , Lied)
                  Else
                           Aktton = Lookup(liedcount , Weihnachten)
               End If
               If Aktton = &HFF Then                        'Test ob Liedtabelle zu Ende ist
                  Liedcount = 0

               End If
            End If
         End If
      End If

   Return

'*** Interrupt-Routine fr externen Interrupt 0
   Isr_int0:                                                'ISR von INT0
      Disable Int0                                          'External Interrupt Request 0 Disable
      'Tastenentprellung und Sturmklingelsperre
      I = 0
      While I < 30                                          'Taste muss mindestens 30 ms gedrckt sein
         If Pind.2 = 0 Then
            Waitms 1                                        'Pause
            I = I + 1
         Else
            I = 0
         End If
      Wend

      I = 0
      While I < 30                                          'Taste muss mindestens 30 ms losgelassen sein
         If Pind.2 = 1 Then
            Waitms 1                                        'Pause
            I = I + 1
         Else
            I = 0
         End If
      Wend
      'Taste wurde erfolgreich gedrckt und losgelassen
      'Jetzt kann die nchste Melodie gespielt werden


      Viertel = 1
      Lang = 1
      Enderr = 0
      If Pind.4 <> Merker Then
               Merker = Pind.4

               Liedcount = 1
      End If
      Enable Timer0

   Return

'***
   Tone:
   Data 59 , 184                                            ' c'     261,63 Hz Timerwerte fr die enspr. Tonhoehen in Hz
   Data 56 , 94                                             ' cis'   277,18 Hz
   Data 53 , 52                                             ' d'     293,66 Hz
   Data 50 , 56                                             ' dis'   311,11 Hz
   Data 47 , 102                                            ' e'     329,63 Hz
   Data 44 , 189                                            ' f'     349,22 Hz
   Data 42 , 58                                             ' fis'   369,99 Hz
   Data 39 , 219                                            ' g'     392,00 Hz
   Data 37 , 158                                            ' gis'   415,33 Hz
   Data 35 , 130                                            ' a'     440,00 Hz
   Data 33 , 132                                            ' b'     466,15 Hz
   Data 31 , 162                                            ' h'     493,89 Hz
   Data 29 , 220                                            ' c''    523,22 Hz
   Data 28 , 46                                             ' cis''  554,40 Hz
   Data 26 , 153                                            ' d''    587,37 Hz

'***
   Lied:
   'Musi01:
   Data &H03 , &H00 , &H05 , &H00 , &H07 , &H00 , &H08 , &H00 , &H0A , &H00 , &H0C , &H00 , &H3A , &H08 , &H00 , &H05 , &H00 , &H3E , &H0A , &H00 , &H07 , &H00 , &HAF

   'Musi02:
   Data &H35 , &H00 , &H2A , &H00 , &H02 , &H05 , &H10 , &H05 , &H10 , &H85

   'Musi03:
   Data &H03 , &H00 , &H05 , &H00 , &H37 , &H3A , &H0E , &H20 , &H1C , &H10 , &H2C , &H00 , &HA7

   'Musi04:
   Data &H47 , &H00 , &H06 , &H00 , &H07 , &H00 , &H0F , &H00 , &H07 , &H00 , &H0E , &H00 , &H0C , &H20 , &H0C , &H20 , &H9C

   'Musi05:
   Data &H0A , &H00 , &H2F , &H10 , &H1E , &H10 , &H0C , &H0A , &H10 , &HA7

   'Musi06:
   Data &H53 , &H17 , &H3A , &H3F , &H3C , &H1F , &H1C , &HBA

   'Musi07:
   Data &H13 , &H20 , &H15 , &H20 , &H17 , &H00 , &H1A , &H1C , &H00 , &H1A , &H1F , &H20 , &H1C , &H20 , &H1A , &HB7

   'Musi08:
   Data &H17 , &H18 , &H3A , &H27 , &H00 , &H27 , &H00 , &H37 , &H95

   'Musi09:
   Data &H33 , &H08 , &H00 , &H0A , &H00 , &H3C , &H3F , &H3C , &H3A , &HB8

   'Musi10:
   Data &H48 , &H00 , &H0A , &H00 , &H08 , &H00 , &H06 , &H00 , &H25 , &H00 , &H21 , &H00 , &HB1

   'Musi11:
   Data &H45 , &H00 , &H03 , &H00 , &H02 , &H00 , &H05 , &H00 , &H0A , &H00 , &H0C , &H00 , &H5E , &H10 , &HBA

   'Musi12:
   Data &H0A , &H00 , &H08 , &H00 , &H0A , &H00 , &H08 , &H00 , &H07 , &H20 , &HB3

   'Musi13:
   Data &H03 , &H00 , &H03 , &H00 , &H25 , &H00 , &H23 , &H00 , &H28 , &H00 , &H47 , &H20 , &H03 , &H00 , &H03 , &H00 , &H25 , &H00 , &H23 , &H00 , &H2A , &H00 , &HC8

   'Musi14:
   Data &H46 , &H00 , &H14 , &H13 , &H14 , &H36 , &H3F , &H3B , &HA6

   'Musi15:
   Data &H15 , &H12 , &H50 , &H12 , &H23 , &H15 , &H0E , &H20 , &H0E , &H20 , &HBA

   'Musi16:
   Data &H28 , &H00 , &H03 , &H00 , &H23 , &H10 , &H38 , &H00 , &H25 , &H00 , &H05 , &H00 , &H25 , &H40 , &H27 , &H00 , &H08 , &H00 , &H2A , &H10 , &H27 , &H10 , &H28 , &H00 , &H0C , &H00 , &HB8

   'Musi17:
   Data &H4A , &H00 , &H07 , &H10 , &H0A , &H10 , &H07 , &H10 , &H0A , &H10 , &H08 , &H10 , &HA8

   'Musi18:
   Data &H0C , &H00 , &H0B , &H00 , &H0C , &H20 , &H0C , &H00 , &H0B , &H00 , &H0C , &H20 , &H0C , &H00 , &H0B , &H00 , &H0C , &H20 , &H0A , &H20 , &H98

   'Musi19:
   Data &H03 , &H00 , &H03 , &H00 , &H28 , &H00 , &H2C , &H00 , &H08 , &H00 , &H08 , &H00 , &H2A , &H00 , &H2D , &H00 , &H03 , &H00 , &H07 , &H00 , &H3A , &H00 , &H0C , &H00 , &H2A , &H00 , &HA8

   'Musi20:
   Data &H03 , &H00 , &H05 , &H00 , &H27 , &H00 , &H07 , &H00 , &H0A , &H00 , &H28 , &H00 , &H08 , &H00 , &H0C , &H00 , &H1A , &H00 , &H0C , &H0A , &H00 , &H08 , &H00 , &HA7

   'Musi21:
   Data &H21 , &H00 , &H46 , &H00 , &H08 , &H00 , &H0B , &H00 , &H0A , &H00 , &H08 , &H00 , &H2D , &H00 , &HAD

   'Musi22:
   Data &H28 , &H00 , &H4D , &H00 , &H08 , &H00 , &H25 , &H00 , &H26 , &H00 , &H48 , &H00 , &H0A , &H00 , &HA8

   'Musi23:
   Data &H23 , &H00 , &H4F , &H00 , &H0E , &H00 , &H2F , &H00 , &H2C , &H00 , &H4D , &H00 , &H0C , &H00 , &H2D , &H00 , &H27 , &H00 , &H0A , &H00 , &H98

   'Musi24:
   Data &H6A , &H00 , &H6A , &H00 , &H0A , &H00 , &H3C , &H30 , &H0A , &H00 , &H2C , &H00 , &H0A , &H00 , &H0C , &H00 , &H2A , &H00 , &H09 , &H00 , &HB8

   'Musi25:
   Data &H0C , &H20 , &H2A , &H20 , &H07 , &H00 , &H05 , &H00 , &H03 , &H00 , &H2C , &H00 , &H2B , &H00 , &HAC

   'Musi26:
   Data &H07 , &H00 , &H05 , &H00 , &H03 , &H00 , &H05 , &H00 , &H07 , &H00 , &H05 , &H00 , &H03 , &H00 , &H05 , &H00 , &H27 , &H00 , &H0C , &H20 , &H27 , &H00 , &H8C

   'Musi27:
   Data &H03 , &H00 , &H05 , &H00 , &H27 , &H00 , &H27 , &H00 , &H08 , &H00 , &H05 , &H00 , &H1C , &H0A , &H00 , &HAA

   'Musi28:
   Data &H23 , &H00 , &H03 , &H00 , &H07 , &H00 , &H2A , &H00 , &H2A , &H00 , &H2A , &H00 , &H0C , &H00 , &H0A , &H00 , &H27 , &H00 , &HA3

   'Musi29:
   Data &H3F , &H3E , &H3C , &H3A , &H3C , &H18 , &H17 , &H25 , &H00 , &HA3

   'Endekennzeichen
   Data &HFF



   Weihnachten:

   'Musi1:
   Data &H11 , &H00 , &H28 , &H00 , &H08 , &H00 , &H38 , &H00 , &H10 , &H1A , &H00 , &H2C , &H00 , &H0C , &H00 , &H3C , &H10 , &H1C , &H00 , &H1A , &H00 , &H1C , &H00 , &H3D , &H00 , &H37 , &H00 , &H3A , &H00 , &HB8

   'Musi2
   Data &H18 , &H00 , &H18 , &H00 , &H18 , &H00 , &H13 , &H00 , &H1C , &H00 , &H1C , &H00 , &H1C , &H00 , &H18 , &H00 , &H1F , &H00 , &H1F , &H00 , &H1D , &H00 , &H1D , &H00 , &H1C , &H00 , &H1C , &H00 , &HBA

   'Musi3
   Data &H3C , &H00 , &H1D , &H00 , &H3F , &H00 , &H1F , &H00 , &H3D , &H00 , &H1C , &H00 , &H3A , &H00 , &H1A , &H00 , &H38 , &H00 , &H1A , &H00 , &H3C , &H00 , &H1C , &H00 , &H3D , &H00 , &H1C , &H00 , &HCA

   'Musi4
   Data &H0F , &H0D , &H00 , &H0C , &H00 , &H0D , &H00 , &H1F , &H00 , &H1C , &H00 , &H18 , &H00 , &H1A , &H00 , &H3C , &H00 , &H0C , &H00 , &H0A , &H00 , &H08 , &H00 , &H0A , &H00 , &H1C , &H00 , &H18 , &H00 , &H13 , &H00 , &H17 , &H00 , &HB8

   'Musi5
   Data &H38 , &H00 , &H25 , &H00 , &H26 , &H00 , &H08 , &H00 , &H0A , &H00 , &H08 , &H00 , &H0A , &H00 , &H38 , &H10 , &H46 , &H00 , &H23 , &H00 , &H28 , &H00 , &HC5

   'Musi6
   Data &H38 , &H00 , &H38 , &H00 , &H18 , &H1A , &H00 , &H18 , &H16 , &H00 , &H35 , &H00 , &H35 , &H00 , &H45 , &H30 , &H36 , &H00 , &H36 , &H00 , &H16 , &H18 , &H00 , &H16 , &H15 , &H00 , &H33 , &H00 , &H33 , &H00 , &HC3

   'Musi7
   Data &H18 , &H00 , &H08 , &H00 , &H3D , &H00 , &H3C , &H00 , &H3A , &H00 , &H38 , &H00 , &H3D , &H00 , &H35 , &H00 , &H38 , &H00 , &H3F , &H00 , &H3C , &H00 , &HFD

   'Musi8
   Data &H31 , &H00 , &H31 , &H00 , &H38 , &H00 , &H38 , &H00 , &H3A , &H00 , &H3A , &H00 , &H78 , &H00 , &H36 , &H00 , &H36 , &H00 , &H35 , &H00 , &H35 , &H00 , &H73 , &H00 , &HF1

   'Musi9
   Data &H11 , &H00 , &H11 , &H00 , &H15 , &H00 , &H38 , &H00 , &H15 , &H00 , &H18 , &H00 , &H1D , &H00 , &H1A , &H00 , &H38 , &H00 , &H15 , &H00 , &H18 , &H00 , &H1A , &H00 , &H18 , &H00 , &H36 , &H00 , &H33 , &H00 , &H18 , &H00 , &H18 , &H00 , &HD5

   'Musi10
   Data &H78 , &H00 , &H7A , &H00 , &H58 , &H00 , &H16 , &H00 , &H35 , &H36 , &H00 , &H78 , &H00 , &H7A , &H00 , &H58 , &H00 , &H16 , &H00 , &H35 , &H36 , &H00 , &H78 , &H00 , &H78 , &H00 , &H7A , &H00 , &H3C , &H00 , &H3D , &H00 , &H7C , &H00 , &H7A , &H00 , &H78 , &HB8

   'Endekennzeichen
   Data &HFF